/* $Id: in.c,v 1.3 2002/01/19 19:15:06 sverrehu Exp $ */
/**************************************************************************
 *
 *  FILE            in.c
 *
 *  DESCRIPTION     Test Internet mappings.
 *
 *  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 *
 **************************************************************************/

#include <stdio.h>
#include <netinet/in.h>

#include "shhnet.h"

/**************************************************************************
 *                                                                        *
 *                       P R I V A T E    D A T A                         *
 *                                                                        *
 **************************************************************************/

static int error = 0;



/**************************************************************************
 *                                                                        *
 *                   P R I V A T E    F U N C T I O N S                   *
 *                                                                        *
 **************************************************************************/

static void
testIn(void)
{
    SNPort port;
    SNAddr addr;
    int    sock;
    char   ip[80], name[80], s[80];
    
    inHostNameToAddr("localhost", &addr);
    inHostAddrToStr(addr, ip);
    printf("inHostNameToAddr/inHostAddrToStr: `localhost' is %s\n", ip);
    inHostAddrToName(addr, name, sizeof(name));
    printf("inHostNameToAddr/inHostAddrToName: %s is `%s'\n", ip, name);
    printf("\n");

    inServiceToPort("echo", "tcp", &port);
    printf("inServiceToPort: echo/tcp is port %d\n", (int) ntohs(port));
    printf("\n");

    tcpClientOpen("localhost", "echo", &sock);
    inGetSockStr(sock, s, sizeof(s), 1);
    printf("inGetSockStr: localhost/echo open connection: `%s'\n", s);
    inGetPeerStr(sock, s, sizeof(s), 1);
    printf("inGetPeerStr: localhost/echo open connection: `%s'\n", s);
    tcpClose(sock);
    printf("\n");
}



/**************************************************************************
 *                                                                        *
 *                    P U B L I C    F U N C T I O N S                    *
 *                                                                        *
 **************************************************************************/

int
main(void)
{
    snInit();

    testIn();

    snFinish();
    if (error)
	fprintf(stderr, "### FAILURE ### FAILURE ### file: `%s'\n", __FILE__);
    return error;
}
