/* $Id: midr.c,v 1.3 2002/01/19 19:15:06 sverrehu Exp $ */
/**************************************************************************
 *
 *  FILE            midr.c
 *
 *  DESCRIPTION     Test MIDR functions.
 *
 *  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 *
 **************************************************************************/

#include <stdio.h>
#include <netinet/in.h>

#include "shhnet.h"
#include "shhmidr.h"

/**************************************************************************
 *                                                                        *
 *                       P R I V A T E    D A T A                         *
 *                                                                        *
 **************************************************************************/

static int error = 0;



/**************************************************************************
 *                                                                        *
 *                   P R I V A T E    F U N C T I O N S                   *
 *                                                                        *
 **************************************************************************/

static void
testMidr(void)
{
    MIDR   *m;
    BYTE   b;
    SDWORD sdw;
    char   s[80];
    int    retPut, retGet;

    m = midrAlloc(100);
    printf("storing B:129, d:-1234 and s:`hello' in midr structure\n");
    retPut = midrPut(m, "Bds", (BYTE) 129, (SDWORD) -1234, "hello");
    midrRewind(m);
    retGet = midrGet(m, "Bds80", &b, &sdw, s);
    printf("put returned %d, get returned %d\n", retPut, retGet);
    printf("got: %u, %ld, `%s'\n", (unsigned) b, (long) sdw, s);
    if (retPut != retGet)
	error = 1;
    if (b != 129 || sdw != -1234 || strcmp(s, "hello") != 0)
	error = 1;
}



/**************************************************************************
 *                                                                        *
 *                    P U B L I C    F U N C T I O N S                    *
 *                                                                        *
 **************************************************************************/

int
main(void)
{
    snInit();

    testMidr();

    snFinish();
    if (error)
	fprintf(stderr, "### FAILURE ### FAILURE ### file: `%s'\n", __FILE__);
    return error;
}
