/* $Id: tcp-client.c,v 1.3 2002/01/19 19:15:06 sverrehu Exp $ */
/**************************************************************************
 *
 *  FILE            tcp-client.c
 *
 *  DESCRIPTION     Test TCP client functions.
 *
 *  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 *
 **************************************************************************/

#include <stdio.h>
#include <string.h>

#include "shhnet.h"
#include "shhmidr.h"

/**************************************************************************
 *                                                                        *
 *                       P R I V A T E    D A T A                         *
 *                                                                        *
 **************************************************************************/

static int error = 0;



/**************************************************************************
 *                                                                        *
 *                   P R I V A T E    F U N C T I O N S                   *
 *                                                                        *
 **************************************************************************/

static void
testTcpClient(void)
{
    int  sock;
    char s[80];

    tcpClientOpen("localhost", "echo", &sock);
    printf("tcpPrintf: sending `abcdefg\\r\\n' to the echo server\n");
    tcpPrintf(sock, "abcdefg\r\n");
    tcpGets(sock, s, sizeof(s));
    printf("tcpGets: `%s'\n", s);
    printf("\n");

    printf("tcpWriteAll: sending `hello '\n");
    tcpWriteAll(sock, "hello ", 6);
    printf("tcpWriteAll: sending `there!\\r\\n'\n");
    tcpWriteAll(sock, "there!\r\n", 8);
    memset(s, '\0', sizeof(s));
    tcpReadAll(sock, s, 3);
    printf("tcpReadAll: got `%s' when reading 3 bytes\n", s);
    memset(s, '\0', sizeof(s));
    tcpReadAll(sock, s, 11);
    printf("tcpReadAll: got `%s' when reading 11 bytes\n", s);
    printf("\n");

    printf("tcpPuts: sending `hello\\r\\nthere\\r\\n'\n");
    tcpPuts(sock, "hello\r\nthere\r\n");
    tcpGets(sock, s, sizeof(s));
    snChopCrLf(s);
    printf("tcpGets/snChopCrLf: got `%s'\n", s);
    tcpGets(sock, s, sizeof(s));
    snChopCrLf(s);
    printf("tcpGets/snChopCrLf: got `%s'\n", s);
    printf("\n");

    tcpClose(sock);
}



/**************************************************************************
 *                                                                        *
 *                    P U B L I C    F U N C T I O N S                    *
 *                                                                        *
 **************************************************************************/

int
main(void)
{
    snInit();

    testTcpClient();

    snFinish();
    if (error)
	fprintf(stderr, "### FAILURE ### FAILURE ### file: `%s'\n", __FILE__);
    return error;
}
